#!/usr/bin/python3

# Solution to Exercise 8: Python for Those with Programming Experience
# (c) Bruce Beckles 2012. Licensed under GPL v3.0

# This script finds an interval containing the square root of 2.0
#   using interval bisection. It stops when it has found an
#   interval that is smaller than 1.0e-15 in size.

tolerance = 1.0e-15	# Size of interval to calculate
lower = 0.0		# Initial lower bound
upper = 2.0		# Initial upper bound
uncertainty = upper - lower	# Size of initial interval

# Keep looping while the interval we've found is still
# too large.
while uncertainty > tolerance:
    # Find the mid-point
    middle = (lower + upper)/2
    
    # If the square of the mid-point is
    #  less than 2.0 (i.e. the mid-point is
    #  less than the square rooot of 2.0)...
    if middle**2 < 2.0:
        # set the lower bound to the mid-point,
        lower = middle
    else:
        # else set the upper bound to the mid-point
        upper = middle

    # Print the new interval
    print(lower, upper)
    # Calculate the size of the new interval
    uncertainty = upper - lower
